diff -NaurdbB -xCVS -xconfigure$ -xconfig.h.in -xMakefile.in mrbayes-3.1.2.old/mcmc.c mrbayes-3.1.2.new/mcmc.c
--- mrbayes-3.1.2.old/mcmc.c	Wed Apr 18 12:19:46 EDT 2007
+++ mrbayes-3.1.2.new/mcmc.c	Thu Nov 22 12:52:14 EST 2007
@@ -33474,6 +34558,387 @@
 			for (i=0; i<theMove->parm->nRelParts; i++)
 				modelSettings[theMove->parm->relParts[i]].upDateCl = YES;
 
+			i = chainId[chn];
+
+			adaptNarrow = NO;
+			adaptWiden = NO;
+			adaptDidNarrow = NO;
+			adaptDidWiden = NO;
+			adaptOnlyIfBack = NO;
+			successRatioUse = 0.4; /* silence GCC */
+
+			if ((chainParams.useAdapt == YES) && (theMove->doAdaptParam == YES) && /* - Allen */
+			    (theMove->nTried[0] >= 50) &&
+			    (theMove->nTriedAfterAdapt >= 20)) {
+			  j = theMove->whichAdaptParam;
+			  minParam = theMove->minAdapt;
+			  maxParam = theMove->maxAdapt;
+			  successRatio1 = ((MrBFlt)(theMove->nAccepted[0]))/((MrBFlt)(theMove->nTried[0]));
+			  successRatio2 = ((MrBFlt)(theMove->nAcceptedAfterAdapt))/
+			    ((MrBFlt)(theMove->nTriedAfterAdapt)); /* just recent */
+			  if ((successRatio1 < 0.7) &&
+			      (successRatio2 < 0.7) &&
+			      (theMove->tuningParam[j] > minParam)) {
+			    if ((0.1 - successRatio1) > LIKE_EPSILON) {
+			      if (((0.1 - successRatio2) > LIKE_EPSILON) &&
+				  (theMove->nTriedAfterAdapt >= 50)) {
+				adaptNarrow = YES;
+				successRatioUse = MinimumValue(successRatio1,successRatio2);
+			      } else {
+				adaptNarrow = YES;
+				adaptOnlyIfBack = YES;
+				if (n >= burninGen)
+				  successRatioUse = successRatio1;
+				else
+				  successRatioUse = MinimumValue(successRatio1,successRatio2);
+			      }
+			    } else if (((0.1 - successRatio2) > LIKE_EPSILON) &&
+				       (theMove->nTriedAfterAdapt >= 50)) {
+			      adaptNarrow = YES;
+			      adaptOnlyIfBack = YES;
+			      if (n >= burninGen)
+				successRatioUse = successRatio2;
+			      else
+				successRatioUse = MinimumValue(successRatio1,successRatio2);
+			    }
+			  } else if ((successRatio1 > 0.1) &&
+				     (successRatio2 > 0.1) &&
+				     (theMove->tuningParam[j] < maxParam)) {
+			    if ((successRatio1 - 0.7) > LIKE_EPSILON) {
+			      if (((successRatio2 - 0.7) > LIKE_EPSILON) &&
+				  (theMove->nTriedAfterAdapt >= 50)) {
+				adaptWiden = YES;
+				successRatioUse = MaximumValue(successRatio1,successRatio2);
+			      } else {
+				adaptWiden = YES;
+				adaptOnlyIfBack = YES;
+				if (n >= burninGen)
+				  successRatioUse = successRatio1;
+				else
+				  successRatioUse = MaximumValue(successRatio1,successRatio2);
+			      }
+			    } else if (((successRatio2 - 0.7) > LIKE_EPSILON) &&
+				       (theMove->nTriedAfterAdapt >= 50)) {
+			      adaptWiden = YES;
+			      adaptOnlyIfBack = YES;
+			      if (n >= burninGen)
+				successRatioUse = successRatio2;
+			      else
+				successRatioUse = MaximumValue(successRatio1,successRatio2);
+			    }
+			  }
+
+			  /* do not alter after partBurninGen unless moving back toward original */
+			  if (n >= partBurninGen)
+			    adaptOnlyIfBack = YES;
+									  
+			  if (adaptOnlyIfBack == YES) {
+			    if (adaptNarrow == YES) {
+			      minParam = theMove->oldTuningParam;
+			      if (theMove->tuningParam[j] <= minParam)
+				adaptNarrow = NO;
+			    } else if (adaptWiden == YES) {
+			      maxParam = theMove->oldTuningParam;
+			      if (theMove->tuningParam[j] >= maxParam)
+				adaptWiden = NO;
+			    }
+			  }
+
+			  if ((theMove->adaptMultiplier == YES) &&
+			      ((adaptNarrow == YES) || (adaptWiden == YES))) {
+			    currParam = exp(theMove->tuningParam[j]/2);
+			    minParamMult = theMove->minAdaptMult;
+			    maxParamMult = theMove->maxAdaptMult;
+			    if (adaptOnlyIfBack == YES) {
+			      if (adaptNarrow == YES)
+				minParamMult = theMove->oldTuningParamMult;
+			      else
+				maxParamMult = theMove->oldTuningParamMult;
+			    }
+
+			    if ((adaptNarrow == YES) && (currParam > minParamMult)) {
+			      if ((currParam > theMove->oldTuningParamMult) && (n < burninGen)) {
+				/* would get to min in 2 moves of this level - slows down as get closer to min */
+				adaptCFactor = sqrt(currParam/theMove->minAdaptMult)-1.0;
+				origAdaptCFactor = CBRT(currParam/theMove->minAdaptMult)-1.0;
+			      } else {
+				/* would get to min in 3 moves of this level - slows down as get closer to min */
+				origAdaptCFactor = adaptCFactor = CBRT(currParam/theMove->minAdaptMult)-1.0;
+			      }
+			      if (currParam > theMove->oldTuningParamMult) {
+				adaptCFactor = MaximumValue(adaptCFactor,((currParam/theMove->oldTuningParamMult)-1.0));
+				origAdaptCFactor =
+				  MaximumValue(origAdaptCFactor,((currParam/theMove->oldTuningParamMult)-1.0));
+			      }
+			      minAdaptCFactor = MinimumValue(theMove->minAdaptCFactor,((currParam/minParamMult)-1.0));
+			      if (adaptCFactor < minAdaptCFactor)
+				adaptCFactor = minAdaptCFactor;
+			      if (origAdaptCFactor < minAdaptCFactor)
+				origAdaptCFactor = minAdaptCFactor;
+			      adaptMult = 1.0/(1.0 + adaptCFactor*((0.1 - successRatioUse)/0.1));
+			      newParamMult = adaptMult*currParam;
+			      if (newParamMult < currParam) { /* roundoff error is not improbable... */
+				if ((origAdaptCFactor < adaptCFactor) && (newParamMult < theMove->oldTuningParamMult)) {
+				  adaptMult = 1.0/(1.0 + origAdaptCFactor*((0.1 - successRatioUse)/0.1));
+				  newParamMult = MinimumValue(theMove->oldTuningParamMult,(adaptMult*currParam));
+				}
+				if (newParamMult < minParamMult)
+				  newParamMult = minParamMult;
+				newParam = 2.0*log(newParamMult);
+				if (newParam < minParam)
+				  newParam = minParam;
+				if (newParam < theMove->tuningParam[j]) {
+				  theMove->tuningParam[j] = newParam;
+				  timesAdaptNarrow++;
+				  adaptDidNarrow = YES;
+				  theMove->nTriedAfterAdapt = 0;
+				  theMove->nAcceptedAfterAdapt = 0;
+				} else if (theMove->tuningParam[j] > maxParam) {
+				  theMove->tuningParam[j] = maxParam;
+				  timesAdaptNarrow++;
+				  adaptDidNarrow = YES;
+				  theMove->nTriedAfterAdapt = 0;
+				  theMove->nAcceptedAfterAdapt = 0;
+				} else if (newParam > theMove->maxAdapt) {
+				  MrBayesPrint ("%s   Error (%2.15lf over maxAdapt %2.15lf; Mult; curr %2.15lf (%2.15lf); min %2.15lf; max %2.15lf) in Adapt for %s\n",
+						spacer, newParam, theMove->maxAdapt, theMove->tuningParam[j], 
+						currParam, minParam, maxParam, theMove->name);
+				  newParam = sqrt(minParam*theMove->tuningParam[j]);
+				  if (newParam > minParam)
+				    newParam = minParam;
+				  if (newParam < theMove->tuningParam[j]) {
+				    theMove->tuningParam[j] = newParam;
+				    timesAdaptNarrow++;
+				    adaptDidNarrow = YES;
+				    theMove->nTriedAfterAdapt = 0;
+				    theMove->nAcceptedAfterAdapt = 0;
+				  }
+				}
+			      } else if (theMove->tuningParam[j] > maxParam) {
+				theMove->tuningParam[j] = maxParam;
+				timesAdaptNarrow++;
+				adaptDidNarrow = YES;
+				theMove->nTriedAfterAdapt = 0;
+				theMove->nAcceptedAfterAdapt = 0;
+			      }
+			    } else if ((adaptWiden == YES) && (currParam < maxParamMult)) {
+			      if ((currParam < theMove->oldTuningParamMult) && (n < burninGen)) {
+				adaptCFactor = sqrt(theMove->maxAdaptMult/currParam)-1.0;
+				origAdaptCFactor = CBRT(theMove->maxAdaptMult/currParam)-1.0;
+			      } else
+				origAdaptCFactor = adaptCFactor = CBRT(theMove->maxAdaptMult/currParam)-1.0;
+			      if (currParam < theMove->oldTuningParamMult) {
+				adaptCFactor = MaximumValue(adaptCFactor,((theMove->oldTuningParamMult/currParam)-1.0));
+				origAdaptCFactor =
+				  MaximumValue(origAdaptCFactor,((theMove->oldTuningParamMult/currParam)-1.0));
+			      }
+			      minAdaptCFactor = MinimumValue(theMove->minAdaptCFactor,((maxParamMult/currParam)-1.0));
+			      if (adaptCFactor < minAdaptCFactor)
+				adaptCFactor = minAdaptCFactor;
+			      if (origAdaptCFactor < minAdaptCFactor)
+				origAdaptCFactor = minAdaptCFactor;
+			      adaptMult = 1.0 + adaptCFactor*((successRatioUse - 0.7)/0.3);
+			      newParamMult = adaptMult*currParam;
+			      if (newParamMult > currParam) {
+				if ((origAdaptCFactor < adaptCFactor) && (newParamMult > theMove->oldTuningParamMult)) {
+				  adaptMult = 1.0 + origAdaptCFactor*((successRatioUse - 0.7)/0.3);
+				  newParamMult = MaximumValue(theMove->oldTuningParamMult,(adaptMult*currParam));
+				}
+				if (newParamMult > maxParamMult)
+				  newParamMult = maxParamMult;
+				newParam = 2.0*log(newParamMult);
+				if (newParam > maxParam)
+				  newParam = maxParam;
+				if (newParam > theMove->tuningParam[j]) {
+				  theMove->tuningParam[j] = newParam;
+				  timesAdaptWiden++;
+				  adaptDidWiden = YES;
+				  theMove->nTriedAfterAdapt = 0;
+				  theMove->nAcceptedAfterAdapt = 0;
+				} else if (theMove->tuningParam[j] < (minParam+theMove->minAdapt)) {
+				  newParam = minParam + theMove->minAdapt;
+				  if (newParam > maxParam)
+				    newParam = maxParam;
+				  if (newParam > theMove->tuningParam[j]) {
+				    theMove->tuningParam[j] = newParam;
+				    timesAdaptWiden++;
+				    adaptDidWiden = YES;
+				    theMove->nTriedAfterAdapt = 0;
+				    theMove->nAcceptedAfterAdapt = 0;
+				  }
+				} else if (newParam < theMove->minAdapt) {
+				  MrBayesPrint ("%s   Error (%2.15lf under minAdapt %2.15lf; Mult; curr %2.15lf (%2.15lf); min %2.15lf; max %2.15lf) in Adapt for %s\n",
+						spacer, newParam, theMove->minAdapt, theMove->tuningParam[j], currParam,
+						minParam, maxParam, theMove->name);
+				  newParam = sqrt(maxParam*theMove->tuningParam[j]);
+				  if (newParam > maxParam)
+				    newParam = maxParam;
+				  if (newParam > theMove->tuningParam[j]) {
+				    theMove->tuningParam[j] = newParam;
+				    timesAdaptWiden++;
+				    adaptDidWiden = YES;
+				    theMove->nTriedAfterAdapt = 0;
+				    theMove->nAcceptedAfterAdapt = 0;
+				  }
+				}
+			      } else if (theMove->tuningParam[j] < (minParam+theMove->minAdapt)) {
+				newParam = minParam + theMove->minAdapt;
+				if (newParam > maxParam)
+				  newParam = maxParam;
+				if (newParam > theMove->tuningParam[j]) {
+				  theMove->tuningParam[j] = newParam;
+				  timesAdaptWiden++;
+				  adaptDidWiden = YES;
+				  theMove->nTriedAfterAdapt = 0;
+				  theMove->nAcceptedAfterAdapt = 0;
+				}
+			      }
+			    }
+			  } else if (adaptNarrow == YES) {
+			    if ((theMove->tuningParam[j] > theMove->oldTuningParam) && (n < burninGen)) {
+			      adaptCFactor = sqrt(theMove->tuningParam[j]/theMove->minAdapt)-1.0;
+			      origAdaptCFactor = CBRT(theMove->tuningParam[j]/theMove->minAdapt)-1.0;
+			    } else
+			      origAdaptCFactor = adaptCFactor = CBRT(theMove->tuningParam[j]/theMove->minAdapt)-1.0;
+			    if (theMove->tuningParam[j] > theMove->oldTuningParam) {
+			      adaptCFactor =
+				MaximumValue(adaptCFactor,((theMove->tuningParam[j]/theMove->oldTuningParam)-1.0));
+			      origAdaptCFactor =
+				MaximumValue(origAdaptCFactor,((theMove->tuningParam[j]/theMove->oldTuningParam)-1.0));
+			    }
+			    if (theMove->tuningParam[j] > minParam)
+			      minAdaptCFactor =
+				MinimumValue(theMove->minAdaptCFactor,((theMove->tuningParam[j]/minParam)-1.0));
+			    else if (theMove->tuningParam[j] > theMove->minAdapt) /* should be! */
+			      minAdaptCFactor =
+				MinimumValue(theMove->minAdaptCFactor,((theMove->tuningParam[j]/theMove->minAdapt)-1.0));
+			    else
+			      minAdaptCFactor = theMove->minAdaptCFactor;
+			    if (adaptCFactor < minAdaptCFactor)
+			      adaptCFactor = minAdaptCFactor;
+			    if (origAdaptCFactor < minAdaptCFactor)
+			      origAdaptCFactor = minAdaptCFactor;
+			    adaptMult = 1.0/(1.0 + adaptCFactor*((0.1 - successRatioUse)/0.1));
+			    newParam = adaptMult*theMove->tuningParam[j];
+			    if (newParam < minParam)
+			      newParam = minParam;
+			    if (newParam < theMove->tuningParam[j]) {
+			      if ((origAdaptCFactor < adaptCFactor) && (newParam < theMove->oldTuningParam)) {
+				adaptMult = 1.0/(1.0 + origAdaptCFactor*((0.1 - successRatioUse)/0.1));
+				newParam = MinimumValue(theMove->oldTuningParam,(adaptMult*theMove->tuningParam[j]));
+			      }
+			      if (newParam < theMove->tuningParam[j]) {
+				theMove->tuningParam[j] = newParam;
+				timesAdaptNarrow++;
+				adaptDidNarrow = YES;
+				theMove->nTriedAfterAdapt = 0;
+				theMove->nAcceptedAfterAdapt = 0;
+			      } else if (theMove->tuningParam[j] > maxParam) {
+				theMove->tuningParam[j] = maxParam;
+				timesAdaptNarrow++;
+				adaptDidNarrow = YES;
+				theMove->nTriedAfterAdapt = 0;
+				theMove->nAcceptedAfterAdapt = 0;
+			      }
+			    } else if (theMove->tuningParam[j] > maxParam) {
+			      theMove->tuningParam[j] = maxParam;
+			      timesAdaptNarrow++;
+			      adaptDidNarrow = YES;
+			      theMove->nTriedAfterAdapt = 0;
+			      theMove->nAcceptedAfterAdapt = 0;
+			    } else if (newParam > theMove->maxAdapt) {
+			      MrBayesPrint ("%s   Error (%2.15lf over maxAdapt %2.15lf; curr %2.15lf) in Adapt for %s\n",
+					    spacer, newParam, theMove->maxAdapt, theMove->tuningParam[j], theMove->name);
+			      newParam = (minParam+theMove->tuningParam[j])/2.0;
+			      if (newParam > minParam)
+				newParam = minParam;
+			      if (newParam < theMove->tuningParam[j]) {
+				theMove->tuningParam[j] = newParam;
+				timesAdaptNarrow++;
+				adaptDidNarrow = YES;
+				theMove->nTriedAfterAdapt = 0;
+				theMove->nAcceptedAfterAdapt = 0;
+			      }
+			    }
+			  } else if (adaptWiden == YES) {
+			    if ((theMove->tuningParam[j] < theMove->oldTuningParam) && (n < burninGen)) {
+			      adaptCFactor = sqrt(theMove->maxAdapt/theMove->tuningParam[j])-1.0;
+			      origAdaptCFactor = CBRT(theMove->maxAdapt/theMove->tuningParam[j])-1.0;
+			    } else
+			      origAdaptCFactor = adaptCFactor = CBRT(theMove->maxAdapt/theMove->tuningParam[j])-1.0;
+			    if (theMove->tuningParam[j] < theMove->oldTuningParam) {
+			      adaptCFactor =
+				MaximumValue(adaptCFactor,((theMove->oldTuningParam/theMove->tuningParam[j])-1.0));
+			      origAdaptCFactor =
+				MaximumValue(origAdaptCFactor,((theMove->oldTuningParam/theMove->tuningParam[j])-1.0));
+			    }
+			    if (maxParam > theMove->tuningParam[j])
+			      minAdaptCFactor =
+				MinimumValue(theMove->minAdaptCFactor,((maxParam/theMove->tuningParam[j])-1.0));
+			    else if (theMove->maxAdapt > theMove->tuningParam[j])
+			      minAdaptCFactor =
+				MinimumValue(theMove->minAdaptCFactor,((theMove->maxAdapt/theMove->tuningParam[j])-1.0));
+			    else
+			      minAdaptCFactor = theMove->minAdaptCFactor;
+			    if (adaptCFactor < minAdaptCFactor)
+			      adaptCFactor = minAdaptCFactor;
+			    if (origAdaptCFactor < minAdaptCFactor)
+			      origAdaptCFactor = minAdaptCFactor;
+			    adaptMult = 1.0 + adaptCFactor*((successRatioUse - 0.7)/0.3);
+			    newParam = adaptMult*theMove->tuningParam[j];
+			    if (newParam > maxParam)
+			      newParam = maxParam;
+			    if (newParam > theMove->tuningParam[j]) {
+			      if ((origAdaptCFactor < adaptCFactor) && (newParam > theMove->oldTuningParam)) {
+				adaptMult = 1.0 + origAdaptCFactor*((successRatioUse - 0.7)/0.3);
+				newParam = MaximumValue(theMove->oldTuningParam,(adaptMult*theMove->tuningParam[j]));
+			      }
+			      if (newParam > theMove->tuningParam[j]) {
+				theMove->tuningParam[j] = newParam;
+				timesAdaptWiden++;
+				adaptDidWiden = YES;
+				theMove->nTriedAfterAdapt = 0;
+				theMove->nAcceptedAfterAdapt = 0;
+			      } else if (theMove->tuningParam[j] < (minParam+theMove->minAdapt)) {
+				newParam = minParam + theMove->minAdapt;
+				if (newParam > maxParam)
+				  newParam = maxParam;
+				if (newParam > theMove->tuningParam[j]) {
+				  theMove->tuningParam[j] = newParam;
+				  timesAdaptWiden++;
+				  adaptDidWiden = YES;
+				  theMove->nTriedAfterAdapt = 0;
+				  theMove->nAcceptedAfterAdapt = 0;
+				}
+			      }
+			    } else if (theMove->tuningParam[j] < (minParam+theMove->minAdapt)) {
+			      newParam = minParam + theMove->minAdapt;
+			      if (newParam > maxParam)
+				newParam = maxParam;
+			      if (newParam > theMove->tuningParam[j]) {
+				theMove->tuningParam[j] = newParam;
+				timesAdaptWiden++;
+				adaptDidWiden = YES;
+				theMove->nTriedAfterAdapt = 0;
+				theMove->nAcceptedAfterAdapt = 0;
+			      }
+			    } else if (newParam < theMove->minAdapt) {
+			      MrBayesPrint ("%s   Error (%2.15lf under minAdapt %2.15lf; curr %2.15lf) in Adapt for %s\n",
+					    spacer, newParam, theMove->minAdapt, theMove->tuningParam[j], theMove->name);
+			      newParam = (maxParam+theMove->tuningParam[j])/2.0;
+			      if (newParam > maxParam)
+				newParam = maxParam;
+			      if (newParam > theMove->tuningParam[j]) {
+				theMove->tuningParam[j] = newParam;
+				timesAdaptWiden++;
+				adaptDidWiden = YES;
+				theMove->nTriedAfterAdapt = 0;
+				theMove->nAcceptedAfterAdapt = 0;
+			      }
+			    }
+			  }
+			}
+
 			/*TouchAllPartitions();*/    /* for debugging copying shortcuts */
 
 			/* make move */
@@ -33488,16 +34953,104 @@
 				}
 
 			/* calculate likelihood ratio */
-			if (abortMove == NO)
-				{
+			if (abortMove == NO) {
 				  /*TouchAllTrees(chn);*/  /* for debugging copying shortcuts */
 				lnLike = LogLike(chn);
 				lnLikelihoodRatio = lnLike - curLnL[chn];
 				lnPrior = curLnPr[chn] + lnPriorRatio;
 
+				if (chainParams.useSA == YES) {
+				  if (n >= burninGen) {
+				    /* no temperature adjustment */
+				  } else if ((n*mult_short) <= 1.0) {
+				    lnLikelihoodRatio *= (tempZero/1000.0);
+				    lnPriorRatio      *= (tempZero/1000.0);
+				  } else if ((lnPriorRatio+lnLikelihoodRatio) > 0.0) {
+				    /* we would like at least 30% refusals */
+				    effectiveGen = ((n-movesAccepted)/0.3);
+				    if (effectiveGen <= 1.0)
+				      tempUse1 = tempZero;
+				    else if (effectiveGen >= partBurninGen)
+				      tempUse1 = 1000;
+				    else {
+				      tempUse1 = (int) (tempZero - (MrBFlt)(mult_short*effectiveGen*1000.0));
+				      if (tempUse1 > 999)
+					tempUse1 = 999;
+				    }
+
+				    tempUse = tempUse1;
+
+				    if (tempUse < 999) {
+				      if (n <= 1)
+					tempUse2 = tempZero;
+				      else
+					tempUse2 = (int) (tempZero - (MrBFlt)(mult_long*(MrBFlt)(n)*1000.0));
+				      if (tempUse2 > 999)
+					tempUse2 = 999;
+				      if (tempUse2 > tempUse)
+					tempUse = tempUse2;
+				    }
+
+				    if (tempUse < 1000) {
+				      if (tempUse < tempZero) {
+					lnLikelihoodRatio *= (tempZero/1000.0);
+					lnPriorRatio      *= (tempZero/1000.0);
+				      } else {
+					lnLikelihoodRatio *= (tempUse/1000.0);
+					lnPriorRatio      *= (tempUse/1000.0);
+				      }
+				    }
+				  } else if ((lnPriorRatio+lnLikelihoodRatio) < 0.0) {
+				    /* admittedly, some prior work (on Adaptive Simulated Annealing - L. Ingber)
+				       indicates that would be best to only decrease effective tempeature
+				       when have had acceptance... may work on later, although admittedly
+				       this somewhat contradicts "annealing" - if no acceptances, is
+				       a sign the system is at "equilibrium"... XXX - Allen */
+				    /* we would like at least 10% acceptances - thus 1/0.1 = 10; + 1.0 is
+				       because n includes this generation */
+				    if ((chainParams.useAdapt == YES) &&
+					(theMove->doAdaptParam == YES))
+				      effectiveGen = (movesAccepted*10.0) + 1.0;
+				    else
+				      effectiveGen = ((theMove->nAccepted[i]*10.0)/theMove->relProposalProb) + 1.0;
+				    if ((effectiveGen*mult_short) <= 1.0)
+				      tempUse1 = tempZero;
+				    else if (effectiveGen >= partBurninGen)
+				      tempUse1 = 1000;
+				    else {
+				      tempUse1 = (int) (tempZero - (MrBFlt)(mult_short*effectiveGen*1000.0));
+				      if (tempUse1 > 999)
+					tempUse1 = 999;
+				    }
+
+				    tempUse = tempUse1;
+
+				    if (tempUse < 999) {
+				      if ((n*mult_long) <= 1.0)
+					tempUse2 = tempZero;
+				      else
+					tempUse2 = (int) (tempZero - (MrBFlt)(mult_long*(MrBFlt)(n)*1000.0));
+				      if (tempUse2 > 999)
+					tempUse2 = 999;
+				      if (tempUse2 > tempUse)
+					tempUse = tempUse2;
+				    }
+
+				    if (tempUse < 1000) {
+				      if (tempUse < tempZero) {
+					lnLikelihoodRatio *= (tempZero/1000.0);
+					lnPriorRatio      *= (tempZero/1000.0);
+				      } else {
+					lnLikelihoodRatio *= (tempUse/1000.0);
+					lnPriorRatio      *= (tempUse/1000.0);
+				      }
+				    }
+				  }
+				} else {
 				/* heat */
-				lnLikelihoodRatio *= Temperature (chainId[chn]);
-				lnPriorRatio      *= Temperature (chainId[chn]);
+				  lnLikelihoodRatio *= Temperature (i);
+				  lnPriorRatio      *= Temperature (i);
+				}
 			
 				/* calculate the acceptance probability */
 				if (lnLikelihoodRatio + lnPriorRatio + lnProposalRatio < -100.0)
@@ -33510,12 +35063,47 @@
 
 			/* decide to accept or reject the move */
 			acceptMove = NO;
-			i = chainId[chn];
+			if (abortMove == NO) {
 			theMove->nTried[i]++;
-			if (abortMove == NO && RandomNumber(seed) < r)
-				{
+			  theMove->nTriedAfterAdapt++;
+			  if ((chainParams.useAdapt == YES) && (theMove->doAdaptParam == YES) &&
+			      ((adaptDidNarrow == YES) || (adaptDidWiden == YES))) {
+			    j = theMove->whichAdaptParam;
+			    if (theMove->minParamTried > theMove->tuningParam[j])
+			      theMove->minParamTried = theMove->tuningParam[j];
+			    if (theMove->maxParamTried < theMove->tuningParam[j])
+			      theMove->maxParamTried = theMove->tuningParam[j];
+			  }
+			  if (RandomNumber(seed) < r) {
 				acceptMove = YES;
 				theMove->nAccepted[i]++;
+			    movesAccepted++;
+			    theMove->nAcceptedAfterAdapt++;
+			    if ((chainParams.useAdapt == YES) && (theMove->doAdaptParam == YES) &&
+				((adaptDidNarrow == YES) || (adaptDidWiden == YES))) {
+			      j = theMove->whichAdaptParam;
+			      if (theMove->minParamAccepted > theMove->tuningParam[j])
+				theMove->minParamAccepted = theMove->tuningParam[j];
+			      /* yes, it can be both above the max and below the min so far (starting vals) */
+			      if (theMove->maxParamAccepted < theMove->tuningParam[j])
+				theMove->maxParamAccepted = theMove->tuningParam[j];
+			      if (adaptDidNarrow)
+				timesAdaptNarrowAccepted++;
+			      else
+				timesAdaptWidenAccepted++;
+			    }
+			  } else if ((chainParams.useAdapt == YES) && (theMove->doAdaptParam == YES) &&
+				     ((adaptDidNarrow == YES) || (adaptDidWiden == YES))) {
+			    j = theMove->whichAdaptParam;
+			    if (theMove->minParamRefused > theMove->tuningParam[j])
+			      theMove->minParamRefused = theMove->tuningParam[j];
+			    if (theMove->maxParamRefused < theMove->tuningParam[j])
+			      theMove->maxParamRefused = theMove->tuningParam[j];
+			    if (adaptDidNarrow)
+			      timesAdaptNarrowRefused++;
+			    else
+			      timesAdaptWidenRefused++;
+			  }
 				}
 
 			/* update the chain */
@@ -33542,13 +35130,20 @@
 		/* attempt swap(s) */
 		if (chainParams.numChains > 1 && n % chainParams.swapFreq == 0)
 			{
-			for (i = 0; i<chainParams.numRuns; i++)
-				{
-				for (j = 0; j<chainParams.numSwaps; j++)
+			  for (i = 0; i<chainParams.numRuns; i++) {
+			    /* the below had previously lacked a bracket... XXX - Allen */
+			    for (j = 0; j<chainParams.numSwaps; j++) {
+#ifdef DEBUG_MPI
+			      MrBayesPrint ("%s   Getting swappers (run %d iteration %d)\n",spacer,i,j);
+#endif
 				GetSwappers (&swapA, &swapB, i);
-				if (AttemptSwap (swapA, swapB, seed) == ERROR)
-					{
+#ifdef DEBUG_MPI
+			      MrBayesPrint ("%s   Swappers are %d and %d\n",spacer,swapA,swapB);
+#endif
+			      if (AttemptSwap (swapA, swapB, seed) == ERROR) {
 #					if defined (MPI_ENABLED)
+				if (proc_id == 0)
+				  MrBayesPrint ("%s   Unsuccessful swap of states\n", spacer);
 					nErrors++;
 #					else
 					MrBayesPrint ("%s   Unsuccessful swap of states\n", spacer);
@@ -33555,16 +35150,92 @@
 					return ERROR;
 #					endif
 					}
+#ifdef DEBUG_MPI
+			      MrBayesPrint ("%s   Tried swapping states\n", spacer);
+#endif
+			    }
 				}
 			}
 
 		/* print information to screen */
-		if (n == 1 || n % chainParams.printFreq == 0)
-			PrintToScreen(n, time(0), startingT);
+		if (n == 1 || n % chainParams.printFreq == 0) {
+		  PrintToScreen(n, movesAccepted, time(0), startingT);
+		  if ((timesAdaptNarrow > 0) || (timesAdaptWiden > 0)) {
+		    MrBayesPrint("%s  Adapt narrowed windows %d times (%d accepted, %d refused), widened %d times (%d accepted, %d refused)\n",
+				 spacer,timesAdaptNarrow,timesAdaptNarrowAccepted,timesAdaptNarrowRefused,
+				 timesAdaptWiden,timesAdaptWidenAccepted,timesAdaptWidenRefused);
+		    timesAdaptNarrow = timesAdaptNarrowAccepted = timesAdaptNarrowRefused = 0;
+		    timesAdaptWiden = timesAdaptWidenAccepted = timesAdaptWidenRefused = 0;
+		  }
+		  if (num_times_scaler_adjusted > 0) { /* - Allen */
+#		    if defined (MPI_ENABLED)
+		    if (proc_id == 0)
+#endif
+		      MrBayesPrint ("%s  WARNING: Scaler adjusted %d times (%d big)\n",spacer,
+				    num_times_scaler_adjusted, num_times_scaler_adjusted_big);
+		    num_times_scaler_adjusted = 0;
+		    num_times_scaler_adjusted_big = 0;
+		  }
+		  if (num_times_scaler_adjusted2 > 0) { /* - Allen */
+#		    if defined (MPI_ENABLED)
+		    if (proc_id == 0)
+#endif
+		      MrBayesPrint ("%s  WARNING: Scaler adjusted (2) %d times (%d big)\n",spacer,
+				    num_times_scaler_adjusted2, num_times_scaler_adjusted2_big);
+		    num_times_scaler_adjusted2 = 0;
+		    num_times_scaler_adjusted2_big = 0;
+		  }
+		  num_times_scaler_warn3 = 0;
+		  if (((chainParams.useSA == YES) ||
+		       (chainParams.useAdapt == YES)) &&
+		      (chainParams.numChains == 1) && (chainParams.numRuns == 1) &&
+		      (((n >= burninGen) && (didReportBurnin == NO)) ||
+		       ((n >= partBurninGen) && (didReportPartBurnin == NO)))) {
+		    MrBayesPrint ("%s   Current acceptance rates for the moves:\n", spacer);
+		    MrBayesPrint ("%s      With prob.  Chain accepted changes to\n", spacer);
+		  
+		    for (i=0; i<numMoves; i++) {
+		      mv = &moves[i];
+		      if (mv->nTried[0] == 0)
+			MrBayesPrint ("%s      not tried   param. %d %s\n", spacer, mv->parm->index+1, mv->name);
+		      else {
+			MrBayesPrint ("%s       %6.2f %%   param. %d %s\n", spacer,
+				      100.0*(MrBFlt)(mv->nAccepted[0])/(MrBFlt)(mv->nTried[0]), mv->parm->index+1,
+				      mv->name);
+			if ((chainParams.useAdapt == YES) && (mv->doAdaptParam == YES)) {
+			  if (mv->nTriedAfterAdapt > 0)
+			    MrBayesPrint("%s       %6.2f %%   param. %d %s after adapt\n", spacer,
+					 100.0*(MrBFlt)(mv->nAcceptedAfterAdapt)/(MrBFlt)(mv->nTriedAfterAdapt),
+					 mv->parm->index+1, mv->name);
+			  else
+			    MrBayesPrint("%s       not tried  param. %d %s after adapt\n", spacer,
+					 mv->parm->index+1, mv->name);
+			  k = mv->whichAdaptParam;
+			  MrBayesPrint("%s     Adapt:             %6.6f to       %6.6f\n",spacer,
+				       mv->oldTuningParam,mv->tuningParam[k]);
+			  MrBayesPrint("%s     Adapt tried:       %6.6f to       %6.6f\n",spacer,
+				       mv->minParamTried, mv->maxParamTried);
+			  MrBayesPrint("%s     Adapt accepted:    %6.6f to       %6.6f\n",spacer,
+				     mv->minParamAccepted, mv->maxParamAccepted);
+			  MrBayesPrint("%s     Adapt refused:     %6.6f to       %6.6f\n",spacer,
+				       mv->minParamRefused, mv->maxParamRefused);
+			}
+		      }
+		    }
+		    if (n >= burninGen) {
+		      didReportPartBurnin = YES;
+		      didReportBurnin = YES;
+		    } else
+		      didReportPartBurnin = YES;
+		  }
+		}
 
 		/* print information to files */
 		if (n == 1 || n == chainParams.numGen || n % chainParams.sampleFreq == 0)
 			{
+#if defined(DEBUG_MPI)
+			  MrBayesPrint ("%s  WARNING: Attempting printing of states\n",spacer);
+#endif
 			if (PrintStatesToFiles (n) == ERROR)
 				{
 #				if defined (MPI_ENABLED)
@@ -33581,6 +35252,9 @@
 			if (chainParams.numRuns > 1 && ((n > 1 && chainParams.relativeBurnin == YES)
 				|| (n >= chainParams.chainBurnIn * chainParams.sampleFreq && chainParams.relativeBurnin == NO)))
 				{
+#if defined(DEBUG_MPI)
+				  MrBayesPrint ("%s  WARNING: Checking tree samples\n",spacer);
+#endif
 				/* we need some space for coming output */
 				MrBayesPrint ("\n");
 				/* first reassemble files if mpi version */				
@@ -33651,6 +35325,9 @@
 				if (chainParams.allComps == YES)
 					PrintTopConvInfo ();
 #				if defined (MPI_ENABLED)
+#                               if defined(DEBUG_MPI)
+				MrBayesPrint ("%s  WARNING: Attempting stopChain broadcast\n",spacer);
+#endif
 					}
 				ierror = MPI_Bcast (&stopChain, 1, MPI_INT, 0, MPI_COMM_WORLD);
 				if (ierror != MPI_SUCCESS)
@@ -33661,6 +35338,9 @@
 #				endif
 				}
 			/* part of the following function needs to be performed by all MPI processors */
+#                       if defined(DEBUG_MPI)
+			MrBayesPrint ("%s  WARNING: Attempting printing of MCMC data\n",spacer);
+#                       endif
 			if (PrintMCMCDiagnosticsToFile (n) == ERROR)
 				nErrors++;
 #			if defined (MPI_ENABLED)
@@ -33688,7 +35368,19 @@
 			{
 			  stoppingT1 = time(0); 
 			  currentCPUTime = clock();
+			  if (currentCPUTime < previousCPUTime) { /* wraparound - Allen */
+			    if ((currentCPUTime < 0) && (previousCPUTime > 0)) { /* Approximating */
+			      if (previousCPUTime > (-1*currentCPUTime)) {
+				CPUTime += (2*(previousCPUTime + currentCPUTime)) / (MrBFlt) (CLOCKS_PER_SEC);
+			      } else {
+				CPUTime += (-2*(previousCPUTime + currentCPUTime)) / (MrBFlt) (CLOCKS_PER_SEC);
+			      }
+			    } else {
+			      CPUTime += (previousCPUTime - currentCPUTime) / (MrBFlt) (CLOCKS_PER_SEC);
+			    }
+			  } else {
 			  CPUTime += (currentCPUTime - previousCPUTime) / (MrBFlt) CLOCKS_PER_SEC;
+			  }
 			  previousCPUTime = currentCPUTime;
 			  chainParams.numGen += ExtendChainQuery ();
 			  stoppingT2 = time(0);
@@ -33713,7 +35405,22 @@
 		} /* end run chain */
 	endingT = time(0);
 	currentCPUTime = clock();
+#if defined(MPI_ENABLED) && defined(DEBUG_MPI) && LAM_MPI
+	MPIL_Trace_off();
+#endif
+	if (currentCPUTime < previousCPUTime) { /* wraparound - Allen */
+	  if ((currentCPUTime < 0) && (previousCPUTime > 0)) { /* Approximating */
+	    if (previousCPUTime > (-1*currentCPUTime)) {
+	      CPUTime += (2*(previousCPUTime + currentCPUTime)) / (MrBFlt) (CLOCKS_PER_SEC);
+	    } else {
+	      CPUTime += (-2*(previousCPUTime + currentCPUTime)) / (MrBFlt) (CLOCKS_PER_SEC);
+	    }
+	  } else {
+	    CPUTime += (previousCPUTime - currentCPUTime) / (MrBFlt) (CLOCKS_PER_SEC);
+	  }
+	} else {
 	CPUTime += (currentCPUTime - previousCPUTime) / (MrBFlt) CLOCKS_PER_SEC;
+	}
 
 	CloseMBPrintFiles (); /* redundant because files closed in FreeChainMemory but kept here as a safeguard in case of future changes */
 
@@ -33805,8 +35512,7 @@
 #	endif
 
 	/* print acceptance rates for the moves */
-	for (j=0; j<chainParams.numChains*chainParams.numRuns; j++)
-		{
+	for (j=0; j<chainParams.numChains*chainParams.numRuns; j++) {
 		if (chainParams.numChains == 1)
 			{
 			if (chainParams.numRuns == 1)
